---
title: Using the CSS properties and values API
slug: Web/API/CSS_Properties_and_Values_API/guide
tags:
  - API
  - CSS
  - CSS Properties and Values
  - Guide
  - Houdini
  - JavaScript
  - Learn
---
<p>{{SeeCompatTable}} The <strong>CSS Properties and Values API</strong> — part of the <a href="/en-US/docs/Web/Houdini">CSS Houdini</a> umbrella of APIs — <span class="seoSummary">allows the registration of {{cssxref('--*', 'CSS custom properties')}}, allowing for property type checking, default values, and properties that do or do not inherit their value.</span></p>

<h2 id="Registering_a_custom_property">Registering a custom property</h2>

<p>Registering a custom property allows you to tell the browser how the custom property should behave; what are allowed types, whether the custom property inherits its value, and what the default value of the custom property is. There are two ways to register a property, in <a href="/en-US/docs/Web/JavaScript">JavaScript</a> or in <a href="/en-US/docs/Web/CSS">CSS</a>.</p>

<h3 id="CSS.registerProperty">CSS.registerProperty</h3>

<p>The following will register a {{cssxref('--*', 'CSS custom properties')}}, <code>--my-prop</code>, using {{domxref('CSS.registerProperty')}}, as a color, give it a default value, and have it not inherit its value:</p>

<pre class="brush: js notranslate">window.CSS.registerProperty({
  name: '--my-prop',
  syntax: '&lt;color&gt;',
  inherits: false,
  initialValue: '#c0ffee',
});
</pre>

<h3 id="property">@property</h3>

<p>The same registration can take place in CSS. The following will register a {{cssxref('--*', 'CSS custom properties')}}, <code>--my-prop</code>, using {{cssxref('@property')}} <a href="/en-US/docs/Web/CSS/At-rule">at-rule</a>, as a color, give it a default value, and have it not inherit its value:</p>

<pre class="brush: css notranslate">@property --my-prop {
  syntax: '&lt;color&gt;';
  inherits: false;
  initial-value: #c0ffee;
}</pre>

<h2 id="Using_registered_custom_properties">Using registered custom properties</h2>

<p>One of the advantages of registering a property is that the browser now knows how it should handle your custom property through things like transitions! When a property isn't registered, the browser doesn't know how to treat it, so it assumes that any value can be used and therefore can't animate it. When a property has a registered syntax, though, the browser can optimize around that syntax, including being able to animate it!</p>

<p>In this example, the custom property <code>--registered</code> has been registered using the syntax <code>&lt;color&gt;</code> and then used in a linear gradient. That property is then transitioned on hover or focus to a different color. Notice that with the registered property the transition works, but that it doesn't with the unregistered property!</p>

<pre class="brush: css notranslate">.registered {
  --registered: #c0ffee;
  background-image: linear-gradient(to right, #fff, var(--registered));
  transition: --registered 1s ease-in-out;
}

.registered:hover,
.registered:focus {
  --registered: #b4d455;
}

.unregistered {
  --unregistered: #c0ffee;
  background-image: linear-gradient(to right, #fff, var(--unregistered));
  transition: --unregistered 1s ease-in-out;
}

.unregistered:hover,
.unregistered:focus {
  --unregistered: #b4d455;
}</pre>

<div class="hidden" id="registered">
<pre class="brush: html notranslate">&lt;button class="registered"&gt;Background Registered&lt;/button&gt;
&lt;button class="unregistered"&gt;Background Not Registered&lt;/button&gt;
</pre>

<pre class="brush: css notranslate">.registered {
  --registered: #c0ffee;
  background-image: linear-gradient(to right, #fff, var(--registered));
  transition: --registered 1s ease-in-out;
}

.registered:hover,
.registered:focus {
  --registered: #b4d455;
}

.unregistered {
  --unregistered: #c0ffee;
  background-image: linear-gradient(to right, #fff, var(--unregistered));
  transition: --unregistered 1s ease-in-out;
}

.unregistered:hover,
.unregistered:focus {
  --unregistered: #b4d455;
}

button {
  height: 40vh;
  display: block;
  width: 100%;
  font-size: 3vw;
}

</pre>

<pre class="brush: js notranslate">window.CSS.registerProperty({
  name: '--registered',
  syntax: '&lt;color&gt;',
  inherits: false,
  initialValue: 'red',
});</pre>
</div>

<p>{{EmbedLiveSample("registered", 320, 320)}}</p>

<p>While not functionally accurate, a good way to think about the difference between the unregistered property in the above example and the registered property is the difference between a {{cssxref('custom-ident')}} and a number when trying to animate {{cssxref('height')}}. You cannot transition or animate from <code>auto</code> to a number because the browser doesn't know what the value of <code>auto</code> is until it's calculated. With an unregisterd property, the browser likewise doesn't know what the value <em>may be</em> until it's calculated, and because of that, it can't set up a transition from one value to another. When registered, though, you've told the browser what type of value it should expect, and because it knows that, it can then set up the transitions properly.</p>

<h2 id="Gotchas">Gotchas</h2>

<p>There are two gotchas when registering a property. The first is that, once a property is registered, there's no way to update it, and trying to re-register it with <a href="/en-US/docs/Web/JavaScript">JavaScript</a> will throw an error indicating it's already been defined.</p>

<p>Second, unlike standard properties, registered properties aren't validated when they're parsed. Rather, they're validated when they're computed. That means both that invalid values won't appear as invalid when inspecting the element's properties, and that including an invalid property after a valid one won't fall back to the valid property. An invalid property will, however, fall back to its registered default.</p>
